var _excluded = ["portal", "show", "animation", "duration", "onClick", "maskAttribute", "children"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { createPortal } from 'react-dom';

var Popover = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Popover, _Component);

  function Popover(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "componentDidMount", function () {});

    _defineProperty(_assertThisInitialized(_this), "onClick", function (e) {
      e.stopPropagation();
    });

    return _this;
  }

  var _proto = Popover.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        portal = _this$props.portal,
        show = _this$props.show,
        animation = _this$props.animation,
        duration = _this$props.duration,
        onClick = _this$props.onClick,
        _this$props$maskAttri = _this$props.maskAttribute,
        maskAttribute = _this$props$maskAttri === void 0 ? {} : _this$props$maskAttri,
        children = _this$props.children,
        others = _objectWithoutPropertiesLoose(_this$props, _excluded); // 构建动画


    var animationClassName = '';

    if (animation !== 'none') {
      animationClassName = 'popup-animation';
    } // 动画时长


    var durationStyle = {};

    if (typeof duration === 'number') {
      durationStyle = {
        WebkitTransitionDuration: duration + 'ms'
      };
    }

    return createPortal( /*#__PURE__*/React.createElement("div", _extends({
      ref: function ref(el) {
        _this2.$el = el;
      }
    }, maskAttribute, {
      className: "mask popover-mask" + (maskAttribute.className ? ' ' + maskAttribute.className : '') + (show ? ' active' : ''),
      style: Object.assign({}, durationStyle, maskAttribute.style || {})
    }), /*#__PURE__*/React.createElement("div", _extends({}, others, {
      className: "popover" + (animationClassName ? ' ' + animationClassName : '') + (others.className ? ' ' + others.className : '') + (show ? ' active' : ''),
      style: Object.assign({}, durationStyle, others.style || {}),
      "data-animation": animation,
      onClick: onClick ? onClick : this.onClick
    }), children && children)), portal || document.getElementById('root') || document.body);
  };

  return Popover;
}(Component);

_defineProperty(Popover, "defaultProps", {
  animation: 'zoom'
});

export { Popover as default };
Popover.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: PropTypes.object,
  show: PropTypes.bool,
  animation: PropTypes.string,
  // slideLeft | slideRight | slideUp | slideDown | zoom | fade
  onClick: PropTypes.func,
  maskAttribute: PropTypes.object,
  children: PropTypes.node
} : {};